/**
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.scheme.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.xtext.example.mydsl.scheme.Define;
import org.xtext.example.mydsl.scheme.SchemePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Define</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.DefineImpl#getVarUm <em>Var Um</em>}</li>
 *   <li>{@link org.xtext.example.mydsl.scheme.impl.DefineImpl#getVarValue <em>Var Value</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DefineImpl extends CommandImpl implements Define
{
  /**
   * The default value of the '{@link #getVarUm() <em>Var Um</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarUm()
   * @generated
   * @ordered
   */
  protected static final String VAR_UM_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getVarUm() <em>Var Um</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarUm()
   * @generated
   * @ordered
   */
  protected String varUm = VAR_UM_EDEFAULT;

  /**
   * The default value of the '{@link #getVarValue() <em>Var Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarValue()
   * @generated
   * @ordered
   */
  protected static final int VAR_VALUE_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getVarValue() <em>Var Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVarValue()
   * @generated
   * @ordered
   */
  protected int varValue = VAR_VALUE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DefineImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SchemePackage.Literals.DEFINE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getVarUm()
  {
    return varUm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setVarUm(String newVarUm)
  {
    String oldVarUm = varUm;
    varUm = newVarUm;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.DEFINE__VAR_UM, oldVarUm, varUm));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getVarValue()
  {
    return varValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setVarValue(int newVarValue)
  {
    int oldVarValue = varValue;
    varValue = newVarValue;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SchemePackage.DEFINE__VAR_VALUE, oldVarValue, varValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SchemePackage.DEFINE__VAR_UM:
        return getVarUm();
      case SchemePackage.DEFINE__VAR_VALUE:
        return getVarValue();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SchemePackage.DEFINE__VAR_UM:
        setVarUm((String)newValue);
        return;
      case SchemePackage.DEFINE__VAR_VALUE:
        setVarValue((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.DEFINE__VAR_UM:
        setVarUm(VAR_UM_EDEFAULT);
        return;
      case SchemePackage.DEFINE__VAR_VALUE:
        setVarValue(VAR_VALUE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SchemePackage.DEFINE__VAR_UM:
        return VAR_UM_EDEFAULT == null ? varUm != null : !VAR_UM_EDEFAULT.equals(varUm);
      case SchemePackage.DEFINE__VAR_VALUE:
        return varValue != VAR_VALUE_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (varUm: ");
    result.append(varUm);
    result.append(", varValue: ");
    result.append(varValue);
    result.append(')');
    return result.toString();
  }

} //DefineImpl
